package ejb;

import javax.ejb.EJB;
import javax.ejb.Stateful;

import javax.naming.InitialContext;
import ejb.SessionBRemote;
import java.util.Properties;


@Stateful
public class SessionABean implements SessionARemote {

//    @EJB(name = "ejb/SessionBBean", beanInterface = SessionBRemote.class)
    SessionBRemote sessionBBean;

    public void call(int id) {


        System.out.println(id + ": Entered SessionABean.call...");

        String lookupName = "java:global/EJBModuleB/SessionBBean!ejb.SessionBRemote";

        try {
            Properties props = new Properties();
            props.put("org.omg.CORBA.ORBInitialPort", "12321");  // hard-coded here, because can't get CORBA interop naming to work in GFV3.x (but it worked in GFV2 ...)

            InitialContext ic = new InitialContext(props);
            sessionBBean = (SessionBRemote)ic.lookup(lookupName );
        } catch (Exception ex) {
            System.out.println(id + ": lookup(" + lookupName + ") failed : " + ex.getMessage());
            System.out.flush();
        }

        if (sessionBBean != null) {
            // sleep to prevent method to finish before other clients
            // have invoked requests...
            System.out.println(id + ": Sleep 5 sec...");
            System.out.flush();
            try {
                Thread.sleep(5000);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }

            System.out.println(id + ": Calling sessionB.call method...");
            System.out.flush();
            sessionBBean.call(id);
        }

        System.out.println(id + ": Leaving SessionABean.call");
        System.out.flush();
    }
}
